<template>
  <q-page class="flex flex-center" style="background-color: #202020">
    <div class="q-pa-lg" style="background-color: #fff; border-radius: 20px">
      <q-form
        v-if="currentForm === 1"
        ref="resetValidation"
        style="color: black"
      >
        <h5 class="text-center text-dark q-ma-md">USER FORM</h5>
        <q-input
          class="q-mb-md"
          filled
          outlined
          v-model="form.name"
          label="Full Name"
          style="width: 300px"
          dense
          color="black"
        >
          <template v-slot:prepend>
            <q-icon name="person" />
          </template>
        </q-input>
        <q-input
          class="q-mb-md"
          filled
          v-model="form.username"
          label="Username"
          style="width: 300px"
          dense
          color="black"
        >
          <template v-slot:prepend>
            <q-icon name="person" />
          </template>
        </q-input>
        <q-input
          class="q-mb-md"
          filled
          v-model="form.email"
          label="Email"
          style="width: 300px"
          dense
          color="black"
        >
          <template v-slot:prepend>
            <q-icon name="email" />
          </template>
        </q-input>
        <q-input
          class="q-mb-md"
          filled
          type="number"
          v-model="form.phone"
          label="Phone Number"
          style="width: 300px"
          dense
          color="black"
        >
          <template v-slot:prepend>
            <q-icon name="phone" />
          </template>
        </q-input>
        <q-input
          class="q-mb-md"
          filled
          v-model="form.website"
          label="Website"
          style="width: 300px"
          dense
          color="black"
        >
          <template v-slot:prepend>
            <q-icon name="public" />
          </template>
        </q-input>
        <div class="text-center">
          <q-btn
            class="q-mb-md"
            label="Next"
            color="dark"
            style="width: 100px"
            push
            @click="currentForm = 2"
          />
        </div>
      </q-form>
      <q-form v-if="currentForm === 2" ref="resetValidation">
        <h5 class="text-center text-dark q-ma-md">COMPLETE ADDRESS</h5>
        <q-input
          class="q-mb-md"
          filled
          v-model="form.address.street"
          label="Street"
          style="width: 300px"
          dense
          color="black"
        >
          <template v-slot:prepend>
            <q-icon name="place" />
          </template>
        </q-input>
        <q-input
          class="q-mb-md"
          filled
          v-model="form.address.suite"
          label="Suite"
          style="width: 300px"
          dense
          color="black"
        >
          <template v-slot:prepend>
            <q-icon name="place" />
          </template>
        </q-input>
        <q-input
          class="q-mb-md"
          filled
          v-model="form.address.city"
          label="City"
          style="width: 300px"
          dense
          color="black"
        >
          <template v-slot:prepend>
            <q-icon name="place" />
          </template>
        </q-input>
        <q-input
          class="q-mb-md"
          filled
          type="number"
          v-model="form.address.zipcode"
          label="Zip Code"
          style="width: 300px"
          dense
          color="black"
        >
          <template v-slot:prepend>
            <q-icon name="place" />
          </template>
        </q-input>
        <template v-slot:prepend>
          <q-icon name="place" />
        </template>
        <q-input
          class="q-mb-md"
          filled
          type="number"
          v-model="form.address.geo.lat"
          label="Latitude"
          style="width: 300px"
          dense
          color="black"
        >
          <template v-slot:prepend>
            <q-icon name="place" />
          </template>
        </q-input>
        <q-input
          class="q-mb-md"
          filled
          type="number"
          v-model="form.address.geo.lng"
          label="Longitude"
          style="width: 300px"
          dense
          color="black"
        >
          <template v-slot:prepend>
            <q-icon name="place" />
          </template>
        </q-input>
        <div class="text-center">
          <q-btn
            label="Back"
            color="dark"
            style="width: 100px; margin-right: 20px"
            push
            @click="currentForm = 1"
          />
          <q-btn
            label="Next"
            color="dark"
            style="width: 100px"
            push
            @click="currentForm = 3"
          />
        </div>
      </q-form>
      <q-form v-if="currentForm === 3" ref="resetValidation">
        <h5 class="text-center text-dark q-ma-md">COMPANY BACKGROUND</h5>
        <q-input
          class="q-mb-md"
          filled
          v-model="form.company.name"
          label="Company Name"
          style="width: 300px"
          dense
          color="black"
        >
          <template v-slot:prepend>
            <q-icon name="business" />
          </template>
        </q-input>
        <q-input
          class="q-mb-md"
          filled
          v-model="form.company.catchPhrase"
          label="Catch Phrase"
          style="width: 300px"
          dense
          color="black"
        >
          <template v-slot:prepend>
            <q-icon name="star" />
          </template>
        </q-input>
        <q-input
          class="q-mb-md"
          filled
          v-model="form.company.bs"
          label="BS"
          style="width: 300px"
          dense
          color="black"
        >
          <template v-slot:prepend>
            <q-icon name="school" />
          </template>
        </q-input>
        <div class="text-center">
          <q-btn
            label="Back"
            color="dark"
            style="width: 100px; margin-right: 20px"
            push
            @click="currentForm = 2"
          />
          <q-btn
            label="SUBMIT"
            color="dark"
            style="width: 100px"
            push
            @click="onSubmit(), showNotif()"
          />
        </div>
      </q-form>
    </div>
  </q-page>
</template>

<script>
import { ref } from "vue";
import { useQuasar } from "quasar";
import { addUserData } from "../composables/axios_data";
let form = ref({
  id: null,
  name: null,
  username: null,
  email: null,
  address: {
    street: null,
    suite: null,
    city: null,
    zipcode: null,
    geo: {
      lat: null,
      lng: null,
    },
  },
  phone: null,
  website: null,
  company: {
    name: null,
    catchPhrase: null,
    bs: null,
  },
});

export default {
  setup() {
    let resetValidation = ref(null);
    let currentForm = ref(1);

    const $q = useQuasar();

    const onSubmit = () => {
      currentForm.value = 1;
      addUserData();
    };

    return {
      resetValidation,
      form,
      onSubmit,
      currentForm,
      addUserData,
      showNotif() {
        $q.notify({
          message: "You added a new user to the user list using the form!",
          color: "dark",
        });
      },
    };
  },
};

export { form };
</script>

<style></style>
